Attribute VB_Name = "__"

'       ========   COM- ========
' :
'  initCOM(2, 9600, 8, 0, 1)     COM2
'  OpenCOM                     
'  WriteCOM("00000")           
'  ReadCOM(12)                 12 
'  CloseCom                   
'------------------------------------------------------------

'    
Type COMMTIMEOUTS
        ReadIntervalTimeout As Long
        ReadTotalTimeoutMultiplier As Long
        ReadTotalTimeoutConstant As Long
        WriteTotalTimeoutMultiplier As Long
        WriteTotalTimeoutConstant As Long
End Type
Type DCB
        DCBlength As Long
        BaudRate As Long
        fBitFields As Long
        wReserved As Integer
        XonLim As Integer
        XoffLim As Integer
        ByteSize As Byte
        parity As Byte
        StopBits As Byte
        XonChar As Byte
        XoffChar As Byte
        ErrorChar As Byte
        EofChar As Byte
        EvtChar As Byte
        wReserved1 As Integer
End Type
'    -
Type OVERLAPPED
        Internal As Long
        InternalHigh As Long
        offset As Long
        OffsetHigh As Long
        hEvent As Long
End Type

' 
Global COMnm$                   ' 
Global BarDCB As DCB            ' 
Global CtimeOut As COMMTIMEOUTS ' 
Global ComNum As Long           '  
Global COMerr$                  '  

'  API
Public Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Public Declare Function PurgeComm Lib "kernel32" (ByVal hFile As Long, ByVal dwFlags As Long) As Long
Public Declare Function SetCommTimeouts Lib "kernel32" (ByVal hFile As Long, lpCommTimeouts As COMMTIMEOUTS) As Long
Public Declare Function SetCommState Lib "kernel32" (ByVal hCommDev As Long, lpDCB As DCB) As Long
Public Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, lpOverlapped As OVERLAPPED) As Long
Public Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, lpOverlapped As OVERLAPPED) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function GetLastError Lib "kernel32" () As Long


'                   
'-------------------------------------------------------------------------------------
':
'    COMn - ,  1 .. 9
'    baud - ,     :
'           50, 110, 150, 300, 600, 1200, 1800, 2000, 2400,
'           3600, 4800, 7200, 9600, 19200, 38400, 115200
'    bits -   
'    parity: 0- (N), 1-, 2-
'    stops -   (1  2)
'    -    (Integer).
'     COM1 9600 8N1    initCOM(1, 9600, 8, 0, 1)
'
'        COMnm$   
'     BarDCB  CtimeOut   OpenCOM.
'
'          ,
'          COMerr$.
'
'        
'     .
'-------------------------------------------------------------------------------------
'
Public Function initCOM(ByVal COMn As Integer, ByVal baud As Long, ByVal bits As Integer, ByVal parity As Integer, ByVal stops As Integer) As String
    Dim retval As Long, ComNum1 As Long

    '     
    BarDCB.DCBlength = 28  '  DCB
    BarDCB.BaudRate = baud '   
    BarDCB.fBitFields = &H83 ' ,    :
            '1 fBinary   .  1 ( Windows 3.x :))
            '2 fParity          1 - ,   .
            '3 fOutxCtsFlow     1 -  CTS:   CTS     CTS.
            '4 OutxDsrFlow      1 -     DSR
            '5,6 fDtrControl      DTR.  ,  , .
            '7 fDsrSensitivity     DSR.  1     ,   DSR.
            '8 fTXContinueOnXoff 0 -      Xoff   Xon.
            '9 fOutX            1 -     Xoff   Xon.
            '10 fInX            1 -     Xon\Xoff
            '11 fErrorChar      1 -           ErrorChar
            '12 fNull           1 -    
            '13,14 fRtsControl  0 -  RTS.       ,   -  .
            '15 fAbortOnError   1 -        ClearCommError.
            '16 fDummy2         =0 ,  .
    BarDCB.wReserved = 0 ' ,   0
    BarDCB.XonLim = 128 '          XON
    BarDCB.XoffLim = 64 '  -        XOFF.          ( )
    BarDCB.ByteSize = bits  '  (- )
    BarDCB.parity = parity  '1- , 2- , 0-  
'    BarDCB.StopBits = 0     '  : 0 -, 1 -, 2 -
    If stops >= 2 Then BarDCB.StopBits = 2 Else BarDCB.StopBits = 0
    BarDCB.XonChar = 17 ',    Xon
    BarDCB.XoffChar = 19 ',    Xoff
    BarDCB.ErrorChar = 35 ',    
    BarDCB.EofChar = 26 ' " "
    BarDCB.EvtChar = 0  '    
    BarDCB.wReserved1 = 0 '.  .
    ' .   -  
    '  ,    .
    CtimeOut.ReadIntervalTimeout = 1 '     .
    CtimeOut.ReadTotalTimeoutConstant = 1 '    
    CtimeOut.ReadTotalTimeoutMultiplier = 1 '     (    )
    CtimeOut.WriteTotalTimeoutConstant = 20 '    
    CtimeOut.WriteTotalTimeoutMultiplier = 5 '     (    )

    initCOM = "": COMerr$ = ""

    If COMn < 1 Then
        initCOM = "  "
        COMerr$ = initCOM
        Exit Function
    End If

    ComNum1 = CreateFile(("COM" + Trim(Str$(COMn))), &HC0000000, 0, 0&, &H3, 0, 0)
    If ComNum1 = -1 Then
        retval = GetLastError()
        initCOM = "  , Error" & Str$(retval)
        COMerr$ = initCOM
        Exit Function
    End If
    retval = PurgeComm(ComNum1, 0) ' , 

    retval = SetCommState(ComNum1, BarDCB)
    If retval = -1 Then
        retval = GetLastError()
        initCOM = "   , Error" & Str$(retval)
        COMerr$ = initCOM
        retval = CloseHandle(ComNum1)
        Exit Function
    End If

    retval = SetCommTimeouts(ComNum1, CtimeOut)
    If retval = -1 Then
        retval = GetLastError()
        initCOM = "   , Error" & Str$(retval)
        COMerr$ = initCOM
        retval = CloseHandle(ComNum1)
        Exit Function
    End If
    retval = CloseHandle(ComNum1)
    COMnm$ = ("COM" + Trim(Str$(COMn)))
End Function


'                 
'--------------------------------------------------------------------------
'    .
'        COMnm$
'        BarDCB  CtimeOut,
'      .
':
'     ComNum
'  ComNum>0   .
'     .
'    ,    ,
'      COMerr$.
'   ,  .
'     ,   CloseCom
'       Windows.
'--------------------------------------------------------------------------
Public Function OpenCOM() As String
    Dim retval As Long

    COMerr$ = ""
    OpenCOM = COMerr$
    If ComNum > 0 Then retval = CloseHandle(ComNum)
    ComNum = CreateFile(COMnm$, &HC0000000, 0, 0&, &H3, 0, 0)
    If ComNum = -1 Then
        retval = GetLastError()
        COMerr$ = "  , Error" & Str$(retval)
        OpenCOM = COMerr$
        Exit Function
    End If
    retval = SetCommState(ComNum, BarDCB)
    If retval = -1 Then
        retval = GetLastError()
        COMerr$ = "   , Error" & Str$(retval)
        OpenCOM = COMerr$
        retval = CloseHandle(ComNum)
        ComNum = -1
        Exit Function
    End If
    retval = SetCommTimeouts(ComNum, CtimeOut)
    If retval = -1 Then
        retval = GetLastError()
        COMerr$ = "   , Error" & Str$(retval)
        OpenCOM = COMerr$
        retval = CloseHandle(ComNum)
        ComNum = -1
        Exit Function
    End If
    retval = PurgeComm(ComNum, 0) ' , 
End Function


Public Function ReadCOM(ByVal numChar As Integer) As String
'   COM
'   ,  ,  .
' -     ,  2047
'(        )
'       COMerr$.

    Dim RetBytes As Long, i As Integer, ReadStr As String, retval As Long
    Dim bRead(2047) As Byte
    Dim lpOverlapped As OVERLAPPED
    
    COMerr$ = ""
    '  
    retval = ReadFile(ComNum, bRead(0), numChar, RetBytes, lpOverlapped)
    If retval = 0 Then
        retval = GetLastError()
        COMerr$ = "   : Error" + Str$(retval)
    End If

    ReadStr = ""
    If (RetBytes > 0) Then
        For i = 0 To RetBytes - 1
            ReadStr = ReadStr + Chr(bRead(i))
        Next i
    End If

    ReadCOM = ReadStr

End Function

Public Function WriteCOM(COMString As String) As String
'  COM.
':
'    .
'      ,
'    COMerr$.

    Dim RetBytes As Long, LenVal As Long, retval As Long
    Dim bRead(2047) As Byte
    Dim lpOverlapped As OVERLAPPED

    COMerr$ = "": WriteCOM = ""
    If COMString = "" Then Exit Function

    ' :   
    '  2048  (   - 2048 )
    If Len(COMString) > 2047 Then
        Call WriteCOM(Left$(COMString, 2047))
        Call WriteCOM(Right$(COMString, Len(COMString) - 2047))
        Exit Function
    End If

    '   
    For LenVal = 0 To Len(COMString) - 1
        bRead(LenVal) = Asc(Mid$(COMString, LenVal + 1, 1))
    Next LenVal

    'a  COM
    retval = WriteFile(ComNum, bRead(0), Len(COMString), RetBytes, lpOverlapped)
    If retval = 0 Then
        retval = GetLastError()
        COMerr$ = "  Error:" + Str$(retval)
        WriteCOM = COMerr$
    End If
End Function

Public Function CloseCom()
'  ,   
    Dim retval As Long
    If ComNum > 0 Then retval = CloseHandle(ComNum)
    ComNum = 0
    COMerr$ = ""
End Function

